#ifndef DEF_COVER
#define DEF_COVER

#include <gecode/driver.hh>
#include <gecode/int.hh>
#include <gecode/set.hh>
#include "gecode/minimodel.hh"
#include <gecode/gist.hh>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <numeric>
#include <fstream>
#include <math.h>
#include <iostream>
#include <sstream> 
#include <vector>
#include <bitset>
#include <climits>
#include <stdio.h>
#include <boost/dynamic_bitset.hpp>

using namespace std;

typedef std::vector < int > VECELE;
typedef std::vector < VECELE > MATELE;

class Cover {
	
	public:
	
		/// Attributs
		vector <int> Liste_Cover;
		vector <int> Frequency;
		vector <int> NotFreqItems; 		
		vector <int> Closure;
		vector <int> Inclusion;
		vector <int> Maximal; //**
		vector <int> Maximal_Inclusion;//**
		
		/// Methodes
		void Initial_Cover(); // compute initial cover
		void Compute_New_Cover(vector <int> item_prefix, Cover *nextCover); // compute the cover incrementaly 
		void Inclusion_test_00(vector <int> sigma_0_new, vector <int> sigma_01); // inclusion test case : p_k = 0 && sum = 0 
		void Inclusion_test_0(int minF, vector <int> sigma_0_new, vector <int> sigma_01); // inclusion test case : p_k = 0 && sum > 0 
		void Frequent_Closed_Itemsets(int minF, vector <int> sigma_1, vector <int> sigma_0, vector <int> sigma_01); // Compute : (no frequent items) + (full extension items) + (items included in any item of sigma_0)		
		void Frequent_Maximal_Itemsets(int minF, vector <int> sigma_1, vector <int> sigma_0, vector <int> sigma_01);	// maximal : there is a bug	
};

#endif //DEF_COVER
